using CommonTools;
using CSRedis;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;

namespace Common
{
    /// <summary>
    /// Redis缓存辅助类
    /// </summary>
    public class CSRedisCacheHelper
    {
        public static CSRedisClient? redis;
        public static CSRedisClient? redis0;
        public static CSRedisClient? redis1;
        public static CSRedisClient? redis2;
        public static CSRedisClient? redis3;
        public static CSRedisClient? redis4;
        public static CSRedisClient? redis5;

        private const string ip = "127.0.0.1";
        private const string port = "6379";
        static CSRedisCacheHelper()
        {
            var redisHostStr = string.Format("{0}:{1}", ip, port);
            if (!string.IsNullOrEmpty(redisHostStr))
            {
                redis0 = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=0");
                redis = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=1");
                redis2 = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=2");
                redis3 = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=3");
                redis4 = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=4");
                //准备存储取电数据
                redis5 = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=5");
                //Native subscribe
                string channel = "__keyevent@4__:expired";
                var QQQ = new ValueTuple<string, Action<CSRedisClient.SubscribeMessageEventArgs>>(channel, (msg) =>
                {
                    try
                    {

                    }
                    catch (Exception ex)
                    {
                    }
                });
                //redis.Subscribe(QQQ);
            }
        }
        /// <summary>
        /// 添加缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <param name="value"></param>
        public static void Set<T>(string key, T value, int ExpireTime)
        {
            redis?.Set(key, value, ExpireTime * 60);
        }

        public static T Get<T>(string key)
        {
            return redis.Get<T>(key);
        }

        public static void Forever<T>(string key, T value)
        {
            redis.Set(key, value, -1);
        }
        public static void Del(string key)
        {
            redis.Del(key);
        }

        public static void Del_Partition(string key, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.Del(key);
        }

        /// <summary>
        /// 判断是否存在
        /// </summary>
        /// <param name="key"></param>
        /// <param name="mac"></param>
        /// <returns></returns>
        public static bool Contains(string key, string mac)
        {
            bool result = redis.Exists(mac);
            if (!result)
            {
                result = redis.Exists(key);
            }
            return result;
        }


        public static int ExpireMinutes = 10;
        public static T Get_Partition<T>(string key, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            return client.Get<T>(key);
        }
        public static void Set_Partition<T>(string key, T value, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.Set(key, value, ExpireMinutes * 60 * 60);
        }

        /// <summary>
        /// 设置过期时间
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <param name="value"></param>
        /// <param name="ExpireTime_Minutes"></param>
        /// <param name="SliceNo"></param>
        public static void Set_PartitionWithTime<T>(string key, T value, int ExpireTime_Minutes, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.Set(key, value, ExpireTime_Minutes * 60);
        }
        public static void Set_PartitionWithForever<T>(string key, T value, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.Set(key, value, -1);
        }
        public static void Del_Partition(string[] key, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.Del(key);
        }
        public static bool Contains_Partition(string key, int SliceNo = 2)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            bool result = client.Exists(key);
            return result;
        }
        private static CSRedisClient WhitchRedisSlice(int SliceNo)
        {
            CSRedisClient client = null;
            if (SliceNo == 1)
            {
                client = redis1;
            }
            else if (SliceNo == 2)
            {
                client = redis2;
            }
            else if (SliceNo == 3)
            {
                client = redis3;
            }
            else if (SliceNo == 4)
            {
                client = redis4;
            }
            else if (SliceNo == 5)
            {
                client = redis5;
            }
            else
            {
                client = redis;
            }
            return client;
        }

        public static long GetForever_ExpireMinutes<T>(string key)
        {
            return redis.Ttl(key);
        }


        /// <summary>
        /// 添加Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <param name="value"></param>
        public static void HMSet(int SliceNo, string key, params object[] value)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.HMSet(key, value);
        }

        public static void HMSet(int SliceNo, int ExpireTime_M, string key, params object[] value)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.HMSet(key, value);
            client.Expire(key, new TimeSpan(0, ExpireTime_M, 0));
        }
        /// <summary>
        /// 获取Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <returns></returns>
        public static T[] HMGet<T>(int SliceNo, string key, string KeyV)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            return client.HMGet<T>(key, KeyV);
        }
        public static Dictionary<string, string> HMGetAll(int SliceNo, string key)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            return client.HGetAll(key);
        }

        /// <summary>
        /// 获取 某个hash值的数量
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        public static int GetHMCount(string key)
        {
            return redis5.HGetAll(key).Count;
        }
        /// <summary>
        /// 删除Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <returns></returns>
        public static long HDelAll<T>(int SliceNo, string key)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            return client.HDel(key);
        }
        public static long HDel(int SliceNo, string key, string key1)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            return client.HDel(key, key1);
        }

        public static void ListAdd(int SliceNo, string key, params object[] obj)
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);
            client.LPush(key, obj);
        }
        public static int MaxLen = 500000;
        public static void StreamAdd(int SliceNo, string key, string Value)
        {
            try
            {
                CSRedisClient client = WhitchRedisSlice(SliceNo);
                // 添加简单消息
                client.XAdd(key, MaxLen, "*", new ValueTuple<string, string>("__data", Value));
            }
            catch (Exception)
            {

            }
        }
        public static void StreamConsume(int SliceNo, string key, string group = "UDPData", string consumer = "Crics1")
        {
            CSRedisClient client = WhitchRedisSlice(SliceNo);

            var data = redis.XReadGroup(group, consumer, 100, 10, new ValueTuple<string, string>(key, ">"));

            if (data != null)
            {
                //检查pending表的长度
                //消费确认前，pending 应该等于2
                var pending = redis.XPending(key, group);
                foreach (var item in data)
                {
                    var idarray = item.Item2;
                    foreach (var SerializeNo in idarray)
                    {
                        var id1 = SerializeNo.Item1;
                        redis.XAck(key, group, id1);
                        redis.XDel(key, id1);
                    }
                }
            }

        }
    }
}
